#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "info4xi.py">
#<abstract4xi abstract = "providing the function info4xi"/>
#<refer4xi reference = "multiprocessing"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'info4xi' ] 
#" 
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:
    import itertools
    import weakref
    import atexit         # most-common ones
except:
    pass
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import logger4xi                        
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "info4xi" usage = "
#     heap4xi.py
#         info('allocating a new mmap of length %d', length)  
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def info4xi(msg, *args):
    '''
    info4xi function provides information during software development
    heap4xi.py: info('allocating a new mmap of length %d', length) 
    '''
    
    # ---------------------------------------------------------------------------------------------    
    # 
    # ---------------------------------------------------------------------------------------------    
    class2print = "info4xi"
    method2print = "info4xi"
    
    message2print = "{started" + "; info4xi-started: " + str(info4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
                
    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
        
    message2print = "{passing" + "; msg-passing-to-print4xi-by-info4xi: " + str(msg) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{informing" + "; replace-informing-by-info4xi: " + " * replace info4xi calls with print4xi calls !"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{returning" + "; info4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
            
#</function4xi> 
#</program4xi>

#<note4xi note = "
    # add more features
    # add multiliguality
    # add graphics (if possible)
    # add statistics    "/>            


    # -------------------------------------------------------------------------------------------------
    # Recorded History                             
    # ------------------------------------------------------------------------------------------------- 
    #<record4xi record = "
    #   test_none4xi.txt
    #   sense-test-none4xi.xml
    #   reason-test-none4xi.xml
    #   ace-test-none4xi.xml
    #"
    #>
    
    
    
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
     

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of end of info4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
